{
  KOL MCK (C) 2000 by Vladimir Kladov

  MCKfakeClasses.inc

  This file redefines mirror class types to PControl / PObj
  to use it by Delphi compiler - while compiling mirror KOL
  project. At design time these definitions are not visible
  for Delphi IDE because of conditional compiling directives.
}

{$I KOLDEF.INC}

  TKOLProject = Pointer;
  TKOLApplet = Pointer;
  TKOLForm = Pointer;
  TKOLDataModule = Pointer;
  TKOLFrame = Pointer;
  TKOLMDIClient = PControl;
  TKOLMDIChild = Pointer;
  TKOLService = Pointer;

  TKOLButton = PControl;
  TKOLLabel = PControl;
  TKOLLabelEffect = PControl;
  TKOLPanel = PControl;
  TKOLSplitter = PControl;
  TKOLGradientPanel = PControl;
  TKOLBitBtn = PControl;
  TKOLGroupBox = PControl;
  TKOLCheckBox = PControl;
  TKOLRadioBox = PControl;
  TKOLEditBox = PControl;
  TKOLMemo = PControl;
  TKOLListBox = PControl;
  TKOLComboBox = PControl;
  TKOLPaintBox = PControl;
  TKOLImageShow = PControl;

  TKOLRichEdit = PControl;
  TKOLProgressBar = PControl;
  TKOLListView = PControl;
  TKOLTreeView = PControl;
  TKOLToolbar = PControl;
  TKOLTabControl = PControl;
  TTabPage = PControl;
  TKOLScrollBox = PControl;

  TKOLTimer = PTimer;
  TKOLThread = PThread;
  TKOLImageList = PImageList;
  TKOLMainMenu = PMenu;
  TKOLPopupMenu = PMenu;
  TKOLOpenSaveDialog = POpenSaveDialog;
  TKOLOpenDirDialog = POpenDirDialog;
  TKOLColorDialog = PColorDialog;
  TKOLTrayIcon = PTrayIcon;

